#include "main.h"
#include "command.h"
#include "suart.h"


u8 combuff[COM_SIZE];


u8 parse_command( struct light *ls )
{
  u8 *s = combuff;
  u8 c;
  u16 val = 0;
  u8 state = 0;

  while( (c = *s++) ){				// until end of string
    c -= '0';					// '0' ... '9'
    switch( state ){

      case VIEW:
      case 0:
	c -= 'A' - '0';
	if( c < 16 ){	          		// channel 'A' ... 'P'
	  ls->channel = c;
	  state++;
	}
	switch( c ){
	  case RAM - 'A': return RAM;		// check RAM usage
	  case START-'A': return START;		// start lightshow
	  case QUIT -'A': return QUIT;		// quit lightshow
	  case VIEW -'A': state = VIEW;		// view lightshow data
	}
	continue;

      case 1:
      case 3:
	if( c >= 10 )				// search number
	  continue;
	state++;
	val = 0;
	break;

      case 2:
	if( c < 10 )				// collect digits
	  break;
	ls->time = val;				// store 1. number
	state++;				// search next number
	continue;

      case 4:
	if( c < 10 )				// collect digits 
	  break;
	state = 5;				// end of 2. number,
						// if not end of string
      default:
	continue;
    }
    val = val * 10 + c;				// add new digit
  }
  if( state >= 4 )				// 4 if end of string
    ls->pwm = val;				// store 2. number
  return state;
}


u8 get_command( void )
{
  static u8 idx = 0;
  u8 c;

  if( kbhit() ){
    c = ugetchar();
    switch( c ){

      case '\n':
      case '\r':
	combuff[idx] = 0;
	idx = 0;
	return 1;			// new command received

      case '\b':
	if( idx ){
	  idx--;
          uputchar( '\b' );
	  uputchar( ' ' );
	  uputchar( '\b' );
	}
	break;

      default:
	if( idx < sizeof(combuff) - 1 ){
	  if( c >= 'a' && c <= 'z' )
	    c += 'A' - 'a';
	  if( c >= ' ' && c <= 'Z' ){
	    combuff[idx++] = c;
	    uputchar( c );
	  }
	}
    }
  }
  return 0;
}
