/************************************************************************/
/*                                                                      */
/*                      16 channel software PWM                         */
/*                                                                      */
/*              Author: P. Dannegger                                    */
/*                                                                      */
/************************************************************************/
#include <stdlib.h>
#include "main.h"
#include "command.h"
#include "pwm16.h"
#include "store.h"
#include "suart.h"
#include "timer.h"
#include "view.h"
#include "xeeprom.h"


void init( void )
{
  DDRA = 0;
  DDRB = 0;
  PORTA = 0xFF;			// pullups on
  PORTB = 0xFF;
  pwm_init();
  suart_init();
  timer_start();
}


int main( void )
{
  u8 start = 1;

  init();
  sei();

  for(;;){
#if 1
    if( start && flag_10ms ){
      flag_10ms = 0;
      timer();
    }
#endif
    if( get_command() ){
      struct light ls;

      uputchar( NEWLINE );
      switch( parse_command( &ls )){

	case 4:
	case 5:
	  store_entry( &ls );
	  break;

	case START:
	  start = 1;
	  timer_start();
	  break;

	case QUIT:
	  start = 0;
	  break;

	case VIEW:
	  view_all();
	  break;

	case VIEW+1:
	  view( ls.channel );
	  break;
      }
    }
  }
}
