#ifndef _main_h_
#define _main_h_


#include <avr\pgmspace.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include "mydefs.h"

#define STX_SIZE	10	// size must be in range 2 .. 256
#define SRX_SIZE	60	// size must be in range 2 .. 256
#define	COM_SIZE	12	// "A_65535_255\n"

#define	XTAL	11.0592e6
#define	BAUD	9600

#define NEWLINE		'\r'


#define F_CPU   XTAL
#include <util\delay.h>

#define	STXD		SBIT( PORTA, PA6 )	// = OC1A
#define	STXD_DDR	SBIT( DDRA,  PA6 )

#define	SRXD_PIN	SBIT( PINA,  PA7 )	// = ICP

#define	MOSI		SBIT( PORTA, PA5 )
#define MOSI_DDR	SBIT( DDRA,  PA5 )
#define	SCK		SBIT( PORTA, PA4 )
#define	SCK_DDR		SBIT( DDRA,  PA4 )
#define RCK		SBIT( PORTA, PA0 )	// TPIC6B595 register clock
#define	RCK_DDR		SBIT( DDRA,  PA0 )

#define	SSDA		SBIT( PORTA, PA2 )
#define	SSDA_DDR	SBIT( DDRA,  PA2 )
#define SSDA_PIN	SBIT( PINA,  PA2 )
#define SSCL		SBIT( PORTA, PA3 )
#define	SSCL_DDR	SBIT( DDRA,  PA3 )


#endif
