#include "main.h"
#include "command.h"
#include "pwm16.h"
#include "xeeprom.h"


u8 store_entry( struct light *ls )
{
  union{
    struct light l;
    u8 b[5];
  }s;
  u16 addr;
  u8 free;

  addr = ls->channel << 10;		// 1024 bytes per channel
  s.l.pwm = ls->pwm;
  if( s.l.pwm > pwm_steps )		// max PWM value
    s.l.pwm = pwm_steps;
  s.b[0] = 0xFF;			// entry free
  s.b[4] = 0xFF;			// next entry free
  s.l.time = ls->time;
  if( ls->time ){			// time > 0: add entry
    for(;;){
      eeprom_rd( addr, 1, &free );	// search free entry
      if( free )
	break;
      addr += 4;		    	// next entry
      if( (addr & 0x03FC) == 0x03FC )
	return 0;				// 0 = error: table full
    };
    s.b[0] = 0;				// entry valid
  }else{				// time = 0: erase list
    s.l.time = 100;			// one second
  }
  return eeprom_wr( addr, 5, s.b );		// 1 = success
}
