#include "main.h"
#include "command.h"
#include "pwm16.h"
#include "xeeprom.h"


struct timer{
  u16 time;
  u8 step;
};

struct timer timers[16];


void timer( void )
{
  u8 i;
  union{
    struct light l;
    u8 b[4];
  }entry;

  for( i = 16; i; i-- ){			// all 16 channel
    if( --timers[i-1].time )
      continue;					// timer not finished
    timers[i-1].step++;				// next step
    eeprom_rd( (timers[i-1].step + ((i-1) << 8)) << 2, 4, entry.b );
    if( entry.b[0] ){				// no further entry
      timers[i-1].step = 0;
      eeprom_rd( (i-1) << 10, 4, entry.b );	// get first entry
    }
    timers[i-1].time = entry.l.time;		// new time
    pwm_set( i-1, entry.l.pwm );		// new pwm
  }
}


void timer_start( void )
{
  u8 i;

  for( i = 16; i; i-- ){
    timers[i-1].time = 1;
    timers[i-1].step = 0;
  }
}
